ADWINDIR=unix_g("cat /etc/adwin/ADWINDIR")
ADWINLIB=ADWINDIR + "/lib/libadwin.so"

link(ADWINLIB, "sl_Boot", "C");
function Boot(Filename)
	call("sl_Boot", Filename, 1, "c", "out")
endfunction

link(ADWINLIB, "sl_Clear_Process", "C");
function Clear_Process(ProcessNo)
	call("sl_Clear_Process", ProcessNo, 1, "i", "out")
endfunction

link(ADWINLIB, "sl_Data_Length", "C");
function Ret=Data_Length(DataNo)
	Ret=call("sl_Data_Length", DataNo, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_Data2File", "C");
function Data2File(Filename, DataNo, StartIndex, Count, Mode)
	call("sl_Data2File", Filename, 1, "c", DataNo, 2, "i", StartIndex, 3, "i", Count, 4, "i", Mode, 5, "i", "out")
endfunction

link(ADWINLIB, "sl_Fifo_Clear", "C");
function Fifo_Clear(FifoNo)
	call("sl_Fifo_Clear", FifoNo, 1, "i", "out")
endfunction

link(ADWINLIB, "sl_Fifo_Empty", "C");
function Ret=Fifo_Empty(FifoNo)
	Ret=call("sl_Fifo_Empty", FifoNo, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_Fifo_Full", "C");
function Ret=Fifo_Full(FifoNo)
	Ret=call("sl_Fifo_Full", FifoNo, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_Free_Mem", "C");
function Ret=Free_Mem(MemSpec)
	Ret=call("sl_Free_Mem", MemSpec, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_Get_FPar", "C");
function Ret=Get_FPar(Index)
	Ret=call("sl_Get_FPar", Index, 1, "i", "out", [1,1], 2, "r")
endfunction

link(ADWINLIB, "sl_Get_FPar_All", "C");
function [Ret]=Get_FPar_All()
	Ret=call("sl_Get_FPar_All", "out", [1,80], 1, "r")
endfunction

link(ADWINLIB, "sl_Get_FPar_Block", "C");
function [Ret]=Get_FPar_Block(StartIndex, Count)
	Ret=call("sl_Get_FPar_Block", StartIndex, 2, "i", Count, 3, "i", "out", [1,Count], 1, "r")
endfunction

link(ADWINLIB, "sl_Get_Last_Error", "C");
function Ret=Get_Last_Error()
	Ret=call("sl_Get_Last_Error", "out", [1,1], 1, "i")
endfunction

link(ADWINLIB, "sl_Get_Last_Error_Text", "C");
function [Ret]=Get_Last_Error_Text(ErrorNumber)
	Ret=call("sl_Get_Last_Error_Text", ErrorNumber, 1, "i", "out", [255,1], 2, "c")
endfunction

link(ADWINLIB, "sl_Get_Par", "C");
function Ret=Get_Par(Index)
	Ret=call("sl_Get_Par", Index, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_Get_Par_All", "C");
function [Ret]=Get_Par_All()
	Ret=call("sl_Get_Par_All", "out", [1,80], 1, "i")
endfunction

link(ADWINLIB, "sl_Get_Par_Block", "C");
function [Ret]=Get_Par_Block(StartIndex, Count)
	Ret=call("sl_Get_Par_Block", StartIndex, 2, "i", Count, 3, "i", "out", [1,Count], 1, "i")
endfunction

link(ADWINLIB, "sl_Get_Processdelay", "C");
function Ret=Get_Processdelay(ProcessNo)
	Ret=call("sl_Get_Processdelay", ProcessNo, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_GetData_Float", "C");
function [Ret]=GetData_Float(DataNo, StartIndex, Count)
	Ret=call("sl_GetData_Float", DataNo, 1, "i", StartIndex, 3, "i", Count, 4, "i", "out", [1, Count], 2, "r")
endfunction

link(ADWINLIB, "sl_GetData_Long", "C");
function [Ret]=GetData_Long(DataNo, StartIndex, Count)
	Ret=call("sl_GetData_Long", DataNo, 1, "i", StartIndex, 3, "i", Count, 4, "i", "out", [1, Count], 2, "i")
endfunction

link(ADWINLIB, "sl_GetData_String", "C");
function [Ret]=GetData_String(DataNo, MaxCount)
// WARNING:

// In some scilab versions, string handling seems to be buggy. In my
// case, eight spaces were prepended to the received string - your
// milage may vary. In my case, when getting "Hello World" from the
// ADwin-system, Scilab acutally printed "        Hello World".
// This bug occurs with Scilab 3.1 on windows and linux, and 4.1 on 
// linux, but _not_ with 4.1 on windows.
// One the bug is fixed, delete the "+8" from the function call.
	Length=String_Length(DataNo)
	if (Length > MaxCount)
		Length = MaxCount
	end
	Ret=call("sl_GetData_String", DataNo, 1, "i", MaxCount, 3, "i", "out", [1,Length+8], 2, "c")
endfunction

link(ADWINLIB, "sl_GetFifo_Float", "C");
function [Ret]=GetFifo_Float(FifoNo, Count)
	Ret=call("sl_GetFifo_Float", FifoNo, 1, "i", Count, 3, "i", "out", [1, Count], 2, "r")
endfunction

link(ADWINLIB, "sl_GetFifo_Long", "C");
function [Ret]=GetFifo_Long(FifoNo, Count)
	Ret=call("sl_GetFifo_Long", FifoNo, 1, "i", Count, 3, "i", "out", [1, Count], 2, "i")
endfunction

link(ADWINLIB, "sl_Load_Process", "C");
function Load_Process(Filename)
	call("sl_Load_Process", Filename, 1, "c", "out")
endfunction

link(ADWINLIB, "sl_Process_Status", "C");
function Ret=Process_Status(ProcessNo)
	Ret=call("sl_Process_Status", ProcessNo, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_Processor_Type", "C");
function Ret=Processor_Type()
	Ret=call("sl_Processor_Type", "out", [1,1], 1, "i")
endfunction

link(ADWINLIB, "sl_Set_DeviceNo", "C");
function Set_DeviceNo(DeviceNo)
	call("sl_Set_DeviceNo", DeviceNo, 1, "i", "out")
endfunction

link(ADWINLIB, "sl_Set_FPar", "C");
function Set_FPar(Index, Value)
	call("sl_Set_FPar", Index, 1, "i", Value, 2, "r", "out")
endfunction

link(ADWINLIB, "sl_Set_Par", "C");
function Set_Par(Index, Value)
	call("sl_Set_Par", Index, 1, "i", Value, 2, "i", "out")
endfunction

link(ADWINLIB, "sl_Set_Processdelay", "C");
function Set_Processdelay(ProcessNo, ProcessDelay)
	call("sl_Set_Processdelay", ProcessNo, 1, "i", ProcessDelay, 2, "i", "out")
endfunction

link(ADWINLIB, "sl_SetData_Float", "C");
function SetData_Float(DataNo, Data, StartIndex)
	Count = size(Data)
	call("sl_SetData_Float", DataNo, 1, "i", Data, 2, "r", StartIndex, 3, "i", Count(2), 4, "i", "out")
endfunction

link(ADWINLIB, "sl_SetData_Long", "C");
function SetData_Long(DataNo, Data, StartIndex)
	Count = size(Data)
	call("sl_SetData_Long", DataNo, 1, "i", Data, 2, "i", StartIndex, 3, "i", Count(2), 4, "i", "out")
endfunction

link(ADWINLIB, "sl_SetData_String", "C");
function SetData_String(DataNo, Data)
	call("sl_SetData_String", DataNo, 1, "i", Data, 2, "c", "out")
endfunction

link(ADWINLIB, "sl_SetFifo_Float", "C");
function SetFifo_Float(FifoNo, Data)
	Count = size(Data)
	call("sl_SetFifo_Float", FifoNo, 1, "i", Data, 2, "r", Count(2), 3, "i", "out")
endfunction

link(ADWINLIB, "sl_SetFifo_Long", "C");
function SetFifo_Long(FifoNo, Data)
	Count = size(Data)
	call("sl_SetFifo_Long", FifoNo, 1, "i", Data, 2, "i", Count(2), 3, "i", "out")
endfunction

link(ADWINLIB, "sl_Start_Process", "C");
function Start_Process(ProcessNo)
	call("sl_Start_Process", ProcessNo, 1, "i", "out")
endfunction

link(ADWINLIB, "sl_Stop_Process", "C");
function Stop_Process(ProcessNo)
	call("sl_Stop_Process", ProcessNo, 1, "i", "out")
endfunction

link(ADWINLIB, "sl_String_Length", "C");
function Ret=String_Length(DataNo)
	Ret=call("sl_String_Length", DataNo, 1, "i", "out", [1,1], 2, "i")
endfunction

link(ADWINLIB, "sl_Test_Version", "C");
function Ret=Test_Version()
	Ret=call("sl_Test_Version", "out", [1,1], 1, "i")
endfunction

link(ADWINLIB, "sl_Workload", "C");
function Ret=Workload(Priority)
	Ret=call("sl_Workload", Priority, 1, "i", "out", [1,1], 2, "i")
endfunction

