// v1.0beta without return values except functions wich are returning values like Get_Par, Get_FPAR...
// v1.01.00 New functions Set_DeviceNo, Get_DeviceNo
// v1.02.00 New functions set_processdelay, get_processdelay, test_version, workload, clear_process, 
//          process_status, get_fpar_all, get_par_all, get_fpar_block, get_par_block, data2file, 
//          free_mem, string_length, getdata_string,  setdata_string, processortyp, setlanguage, 
//          adwin_debug_mode_on, adwin_debug_mode_off

adwin = link("C:\ADwin\Developer\Scilab\ADwin32interface.dll", "madboot_", "c");
link(adwin, "madbload_", "c");
link(adwin, "madb_start_", "c");
link(adwin, "madb_stop_", "c");
link(adwin, "mset_adbpar_", "c");
link(adwin, "mset_adbfpar_", "c");
link(adwin, "mget_adbpar_", "c");
link(adwin, "mget_adbfpar_", "c");
link(adwin, "mget_data_length_", "c");
link(adwin, "mget_data_", "c");
link(adwin, "mset_data_", "c");
link(adwin, "mget_fifo_", "c");
link(adwin, "mset_fifo_", "c");
link(adwin, "mfifo_full_", "c");
link(adwin, "mfifo_empty_", "c");
link(adwin, "mfifo_clear_", "c");
link(adwin, "mget_last_error_", "c");
link(adwin, "mget_last_error_text_", "c");
link(adwin, "merror_length_", "c");
link(adwin, "mgetdatatyp_", "c");
link(adwin, "mset_processdelay_", "c");
link(adwin, "mget_processdelay_", "c");
link(adwin, "mtest_version_", "c");
link(adwin, "mworkload_", "c");
link(adwin, "mclear_process_", "c");
link(adwin, "mprocess_status_", "c");
link(adwin, "mget_fpar_all_", "c");
link(adwin, "mget_par_all_", "c");
link(adwin, "mget_fpar_block_", "c");
link(adwin, "mget_par_block_", "c");
link(adwin, "mdata2file_", "c");
link(adwin, "mfree_mem_", "c");
link(adwin, "mstring_length_", "c");
link(adwin, "mgetdata_string_", "c");
link(adwin, "msetdata_string_", "c");
link(adwin, "mprocessortyp_", "c");
link(adwin, "msetlanguage_", "c");
link(adwin, "madwin_debug_mode_on_", "c");
link(adwin, "madwin_debug_mode_off_", "c");


// Set the global device number for the ADwin System
global DeviceNo;
DeviceNo = 336;

// Set the global variable to distin number for the ADwin System
global messageBox;
messageBox = 0; 	// default message to off (Boot, Load, Test_Version)

// Show_Errors enables or disables the display of error messages in a message box.
// Error messages for Test_Version, ADBload, Boot    0/1 -> (off/on)
// ==============================================================================
function Show_Errors(OnOff)
	global messageBox;
  	messageBox=OnOff;
endfunction

// Set_DeviceNo sets the device number.
// ===================================================================
function Set_DeviceNo(gDeviceNo)
  global DeviceNo;
  DeviceNo = gDeviceNo;
endfunction

// Get_DeviceNo returns the current device number.
// ===================================================================
function [x] = Get_DeviceNo()
  global DeviceNo;
  x=DeviceNo;
endfunction

// Boot initializes the ADwin system and loads the file of the operating system.
// ===================================================================
function Boot(Filename)
  call("madboot_", Filename,1, "c", DeviceNo, 2, "i", 0, 3, "i", messageBox, 4, "i", "out");
endfunction

// Start_Process starts a process.
// ===================================================================
function Start_Process(ProcessNo)
  call("madb_start_", ProcessNo,1, "i", DeviceNo, 2, "i", "out");
endfunction

// Load_Process loads the binary file of a process into the ADwin system.
// ===================================================================
function Load_Process(Filename)
  call("madbload_", Filename,1, "c", DeviceNo, 2, "i", messageBox, 3, "i","out");
endfunction

// Stop_Process stops a process.
// ===================================================================
function Stop_Process(ProcessNo)
  call("madb_stop_", ProcessNo,1, "i", DeviceNo, 2, "i","out");
endfunction

// Clear_Process deletes a process from memory.
// ===================================================================
function Clear_Process(ProcessNo)
  call("mclear_process_", ProcessNo, 1, "i", DeviceNo, 2, "i", "out");
endfunction

// Process_Status returns the status of a process.
// ===================================================================
function [x] = Process_Status(ProcessNo)
  x =  call("mprocess_status_", ProcessNo, 1, "i", DeviceNo, 2, "i", "out", [1,1], 3, "i");
endfunction


// Get_Par returns the value of a global LONG variable.
// ===================================================================
function [x] = Get_Par(ParameterNo)
  x =  call("mget_adbpar_", ParameterNo, 1, "i", DeviceNo, 2, "i", "out", [1,1], 3, "i");
endfunction

// Get_Par_All transfers all global long variables (PAR_1PAR_80) into a row vector.
// ===================================================================
function [count] = Get_Par_All()
  count = call("mget_par_all_", DeviceNo, 2,"i", "out", [1, 80], 1, "i"); 
endfunction

// Get_Par_Block transfers a specified number of global LONG variables into a row vector.
// ===================================================================
function [count] = Get_Par_Block(StartIndex, Count)
  count = call("mget_par_block_", StartIndex, 1,"i", Count, 2,"i", DeviceNo, 4,"i", "out", [1, Count], 3, "i"); 
endfunction

// Get_Par returns the value of a global FLOAT variable.
// ===================================================================
function [x] = Get_FPar(ParameterNo)
  x =  call("mget_adbfpar_", ParameterNo, 1, "i", DeviceNo, 2, "i", "out", [1,1], 3, "r");
endfunction

// Get_FPar_Block transfers a number of global FLOAT variables, which is to be indicated, into a row vector.
// ===================================================================
function [count] = Get_FPar_Block(StartIndex, Count)
  count = call("mget_fpar_block_", StartIndex, 1,"i", Count, 2,"i", DeviceNo, 4,"i", "out", [1, Count], 3, "r"); 
endfunction

// Get_FPar_All transfers all global float variables (FPAR_1FPAR_80) into a row vector.
// ===================================================================
function [count] = Get_FPar_All()
  count = call("mget_fpar_all_", DeviceNo, 2,"i", "out", [1, 80], 1, "r"); 
endfunction

// Set_Par sets a global LONG variable to the specified value.
// ===================================================================
function Set_Par(ParNo, Value)
  call("mset_adbpar_", ParNo, 1, "i", Value, 2, "i", DeviceNo, 3, "i", "out");
endfunction

// Set_FPar sets a global FLOAT variable to a specified value.
// ===================================================================
function Set_FPar(ParNo, FloatValue)
  call("mset_adbfpar_", ParNo, 1, "i", FloatValue, 2, "r", DeviceNo, 3, "i", "out");
endfunction

// GetData_Long transfers parts of a DATA array from an ADwin system into a row vector.
// ===================================================================
function [count] = GetData_Long(DataNo, Startindex, Count)
  count = call("mget_data_", 2, 2, "i", DataNo, 3, "i", Startindex, 4, "i", Count, 5, "i", DeviceNo, 6, "i", "out", [1, Count], 1, "i"); 
endfunction

// GetData_Float transfers parts of a DATA array from an ADwin system into a row vector.
// ===================================================================
function [count] = GetData_Float(DataNo, Startindex, Count)
  count = call("mget_data_", 5, 2, "i", DataNo, 3, "i", Startindex, 4, "i", Count, 5, "i", DeviceNo, 6, "i", "out", [1, Count], 1, "r"); 
endfunction

// Data2File saves data from a DATA array of the ADwin system into a file (on the hard disk).
// ===================================================================
function Data2File(Filename, DataNo, Startindex, Count, Mode)
  call("mdata2file_", Filename,1, "c",  DataNo, 2, "i",  Startindex, 3, "i", Count, 4, "i", Mode, 5, "i", DeviceNo, 6, "i", "i", "out");
endfunction

// SetData_Long transfers data from a row vector into a DATA array of the ADwin system.
// ===================================================================
function SetData_Long(DataNo, Vector, Startindex)
  Count=size(Vector)

  call("mset_data_", 2, 2, "i", DataNo, 3, "i", Startindex, 4, "i", Count(2), 5, "i", DeviceNo, 6, "i", Vector, 1, "i", "out");
endfunction

// SetData_Float transfers data from a row vector into a DATA array of the ADwin system. 
// ===================================================================
function SetData_Float(DataNo, Vector, Startindex)
  Count=size(Vector)

  call("mset_data_", 5, 2, "i", DataNo, 3, "i", Startindex, 4, "i", Count(2), 5, "i", DeviceNo, 6, "i", Vector, 1, "r", "out");
endfunction

// Data_Length returns the length of an ADbasic array, that is the number of elements.
// ===================================================================
function [x] = Data_Length(DataNo)
  x =  call("mget_data_length_", DataNo, 1, "i", DeviceNo, 2, "i", "out", [1,1], 3, "i");
endfunction

// GetFifo_Long transfers FIFO data from a FIFO array to a row vector.
// ===================================================================
function [Count] = GetFifo_Long(FifoNo, Count)
  Count = call("mget_fifo_", 2, 2, "i", FifoNo, 3, "i", Count, 4, "i", DeviceNo, 5, "i", "out", [1, Count], 1, "i")
endfunction

// GetFifo_Float transfers FIFO data from a FIFO array to a row vector.
// ===================================================================
function [Count] = GetFifo_Float(FifoNo, Count)
  Count = call("mget_fifo_", 5, 2, "i", FifoNo, 3, "i", Count, 4, "i", DeviceNo, 5, "i", "out", [1, Count], 1, "r")
endfunction

// SetFifo_Long transfers data from a row vector into a FIFO array.
// ===================================================================
function SetFifo_Long(FifoNo, Vector)
  Count=size(Vector)

  call("mset_fifo_", 2, 2, "i", FifoNo, 3, "i", Count(2), 4, "i", DeviceNo, 5, "i", Vector, 1, "i", "out");
endfunction

// SetFifo_Float transfers data from a row vector into a FIFO array.
// ===================================================================
function SetFifo_Float(FifoNo, Vector)
  Count=size(Vector)

  call("mset_fifo_", 5, 2, "i", FifoNo, 3, "i", Count(2), 4, "i", DeviceNo, 5, "i", Vector, 1, "r", "out");
endfunction

// Fifo_Full returns the number of used elements of a FIFO array.
// ===================================================================
function [x] = Fifo_Full(FifoNo)
  x =  call("mfifo_full_", FifoNo,1, "i", DeviceNo, 2, "i", "out", [1,1],3, "i");
endfunction

// Fifo_Empty returns the number of empty elements in a FIFO array.
// ===================================================================
function [x] = Fifo_Empty(FifoNo)
  x = call("mfifo_empty_", FifoNo,1, "i", DeviceNo, 2, "i", "out", [1,1],3, "i");
endfunction

// Fifo_Clear initializes the write and read pointers of a FIFO array. Now the
// data in the FIFO array are no longer available.
// ===================================================================
function Fifo_Clear(FifoNo)
  call("mfifo_clear_", FifoNo,1, "i", DeviceNo, 2, "i", "out");
endfunction

// Get_Last_Error returns the number of the error that occured last in the adwin32.dll
// ===================================================================
function [x] = Get_Last_Error()
  x =  call("mget_last_error_", "out", [1,1], 1, "i");
endfunction

// Get_Last_Error_Text returns the error text to a given error number.
// ===================================================================
function [Text] = Get_Last_Error_Text(Last_Error)
  elength = call("merror_length_", Last_Error, 1, "i", "out", [1,1], 2, "i");
  Text = call("mget_last_error_text_", Last_Error, 1, "i", "out", [1, elength], 2, "c");
endfunction

// Set_Processdelay sets the parameter Processdelay for a process
// ===================================================================
function Set_Processdelay(ProcessNo, Value)
  call("mset_processdelay_", ProcessNo, 1, "i", Value, 2, "i", DeviceNo, 3, "i", "out");
endfunction

// Get_Processdelay returns the parameter Processdelay for a process.
// ===================================================================
function [x] = Get_Processdelay(ProcessNo)
  x =  call("mget_processdelay_", ProcessNo, 1, "i", DeviceNo, 2, "i", "out", [1,1], 3, "i");
endfunction

// Test_Version checks, if the correct operating system for the processor has
// been loaded and if the processor can be accessed.
// ===================================================================
function [x] = Test_Version()
  x =  call("mtest_version_", DeviceNo, 1, "i", messageBox , 2, "i", "out", [1,1], 3, "i");
endfunction

// Workload returns the average processor workload since the last call of Workload.
// ===================================================================
function [x] = Workload(Priority)
  x =  call("mworkload_",Priority , 1, "i", DeviceNo , 2, "i", "out", [1,1], 3, "i");
endfunction

// Free_Mem returns the free memory of the system for the different memory types.
// ===================================================================
function [x] = Free_Mem(Mem_Spec)
  x =  call("mfree_mem_",Mem_Spec , 1, "i", DeviceNo , 2, "i", "out", [1,1], 3, "i");
endfunction

// String_Length returns the length of a data string in a DATA array.
// ===================================================================
function [str_length] = String_Length(DataNo)
    str_length = call("mstring_length_", DataNo, 1, "i", DeviceNo , 2, "i", "out", [1,1], 3, "i");
endfunction

// GetData_String transfers a string from a DATA array into a string variable.
// ===================================================================
function [Text] = GetData_String (DataNo, MaxCount)
    Text = call("mgetdata_string_", MaxCount, 2, "i",  DataNo, 3, "i", DeviceNo , 4, "i", "out", [1, MaxCount], 1, "c");
endfunction

// SetData_String transfers a string into DATA array.
// ===================================================================
function SetData_String(DataNo, Vector_String)
  call("msetdata_string_", Vector_String, 1, "c", DataNo, 2, "i", DeviceNo, 3, "i", "out");
endfunction

// Processor_Type returns the processor type of the system. 9=T9; 1010=T10; 1011=T11
// ===================================================================
function [x] = Processor_Type ()
  x =  call("mprocessortyp_",  DeviceNo, 1, "i", "out", [1,1], 2, "i");
endfunction

// Set_Language sets the language for the error messages.
// ===================================================================
function Set_Language(Language)
  call("msetlanguage_", Language,1, "i", "out");
endfunction

// Only for support
// ===================================================================
function ADwin_Debug_Mode_On(Filename, Size)
  call("madwin_debug_mode_on_", Filename,1, "c", Size, 2, "i", "out");
endfunction

// Only for support
// ===================================================================
function ADwin_Debug_Mode_Off()
  call("madwin_debug_mode_off_", "out");
endfunction
